NLVersion="1.0.0"
--WoW Persistent Settings

function NightLight_OnLoad(self)
  DEFAULT_CHAT_FRAME:AddMessage("NightLight " .. NLVersion .." Loaded.", 0.75,0.75,0)
  DEFAULT_CHAT_FRAME:AddMessage("/nl in default chat for a list of commands!", 0.5,0.5,0)

  --Need only a simple set of slash commands
  SLASH_NightLight1 = "/nl";
  SlashCmdList["NL"] = NightLight_SlashHandler;
end

function NL_gSlider_OnLoad(self)
  local gammaSetting
  gammaSetting =   GetCVar("Gamma");
  gammaSetting = gammaSetting * 10 ;

  self:SetMinMaxValues(6,18);
  self:SetValueStep(1);
  self:SetValue(gammaSetting);
  self:RegisterEvent("CURSOR_UPDATE");

  --DEFAULT_CHAT_FRAME:AddMessage("NightLight Slider Setup Complete." , 0.5,0,0);
  self:Show();
end

function NL_gSlider_OnEvent(self,event)
    if event == "CURSOR_UPDATE" then
		NL_gSlider_Sync(self);
    end
end

function NL_gSlider_OnValueChanged(self)
local value = self:GetValue()
  --DEFAULT_CHAT_FRAME:AddMessage("Slider:" .. value, 0,0.5,0)
  value = value/10
  SetCVar("Gamma",value)
 end

function NL_gSlider_Sync(self)
  local gammaSetting
  gammaSetting =   tostring(10*GetCVar("Gamma"))
  if gammaSetting ~= tostring(self:GetValue()) then 
    self:SetValue(gammaSetting);
	--DEFAULT_CHAT_FRAME:AddMessage("NightLight Slider Updated to " .. gammaSetting , 0.75,0,0);
  end
end

--Callback for slashcommand handling. /load
function SlashCmdList.NightLight(msg, editBox)
    local cmd = msg:lower()
    
	--display the valid list of commands
    if cmd=="" then 
	  DEFAULT_CHAT_FRAME:AddMessage("NightLight " .. NLVersion , 0.75,0.75,0)
      DEFAULT_CHAT_FRAME:AddMessage("/nl ver[sion]", 0.65,0.65,0);
      DEFAULT_CHAT_FRAME:AddMessage("/nl reset (to top left, gamma 1.0)", 0.65,0.65,0);
      DEFAULT_CHAT_FRAME:AddMessage("/nl (one of) n[ight], d[ay], \[ 0.3 \>= number \<= 2.0\ \]", 0.65,0.65,0);
	  DEFAULT_CHAT_FRAME:AddMessage("(Note) Alt+Click (on left/right edge) and drag to move.", 0.65,0.65,0);
    end
	
    if cmd=="ver" or cmd=="version" then 
      reportVersion()
	  
    elseif cmd=="n" or cmd=="night" then 
      setNightVision()

    elseif cmd=="d" or cmd=="day" then 
      setDayVision()

    elseif cmd=="reset" or cmd=="reset position" then 
	  NightLightFrame:ClearAllPoints()
	  NightLightFrame:SetPoint("TOPLEFT", UIParent)
	  setDayVision()
    else 
	  if tonumber(cmd) ~= nil then 
		if tonumber(cmd) >= 0.3 and tonumber(cmd) <= 2.0 then  
	      SetCVar("Gamma", tonumber(cmd))
		  gammaSlider:SetValue(10 * tonumber(cmd));
		end
	  end 
    end
	
end

function reportVersion()
   DEFAULT_CHAT_FRAME:AddMessage("NightLight is at Version " .. NLVersion, 0,0.5,0)
end

--Test functionality
function testFunction()
   print("Initiating Test")
   print("Test Complete!")
end


function setNightVision()
  SetCVar("Gamma", 1.4) 
  DEFAULT_CHAT_FRAME:AddMessage("Gamma: " .. GetCVar("Gamma"), 0,0.5,0)
end

function setDayVision()
  SetCVar("Gamma", 1.0) 
  DEFAULT_CHAT_FRAME:AddMessage("Gamma: " .. GetCVar("Gamma"), 0,0.5,0)
end
